"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("react");
const Effects = __importStar(require("./effects"));
exports.Effects = Effects;
const removeEffects = 0;
const domainAction = 1;
/* istanbul ignore next */
function throwIfNotNever(x) {
    if (!!x) {
        throw new TypeError(`Expected value ${x} to be of type "never"`);
    }
    return x;
}
function makeElmishReducer(reducer) {
    return ([prevState, prevEffects], action) => {
        switch (action[0]) {
            case 0: {
                const nextEffects = prevEffects.filter(x => !action[1].includes(x));
                return [prevState, nextEffects];
            }
            case 1: {
                const [nextState, newEffects] = reducer(prevState, action[1]);
                return [
                    nextState,
                    [...prevEffects, ...newEffects]
                ];
            }
            /* istanbul ignore next */
            default: {
                return throwIfNotNever(action[0]);
            }
        }
    };
}
function useElmish(reducer, initializer) {
    const memoizedReducer = react_1.useCallback(makeElmishReducer(reducer), [reducer]);
    const [[state, effects], dispatch] = react_2.useReducer(memoizedReducer, null, initializer);
    const subDispatch = react_1.default.useCallback((action) => dispatch([domainAction, action]), [dispatch]);
    react_2.useEffect(() => {
        if (effects.length > 0) {
            const eff = [...effects];
            dispatch([removeEffects, eff]);
            eff.forEach(x => x(subDispatch));
        }
    }, [effects]);
    return [state, subDispatch];
}
exports.useElmish = useElmish;
exports.default = useElmish;
